///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define PleaseEnterValidReg "Please enter a valid 24 character registration code."

BOOL CALLBACK RegistrationDialog(HWND xHandle, UINT xMessage, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HWND RegKey1_hWnd = NULL;
    static HWND RegKey2_hWnd = NULL;
    static HWND RegKey3_hWnd = NULL;

    //--------------------------------------------------------------------------

    if(xMessage == WM_INITDIALOG) // Received A Initilize Dialog Message
    {
        RegistrationDialog_hWnd = xHandle;

        SendMessage(RegistrationDialog_hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)"Select Database");
        SendMessage(RegistrationDialog_hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(MainInstance, MAKEINTRESOURCE(DialogIcon)) );

        RegKey1_hWnd = GetDlgItem(RegistrationDialog_hWnd, IDC_REGKEY1);
        RegKey2_hWnd = GetDlgItem(RegistrationDialog_hWnd, IDC_REGKEY2);
        RegKey3_hWnd = GetDlgItem(RegistrationDialog_hWnd, IDC_REGKEY3);

        SendMessage(RegKey1_hWnd, EM_LIMITTEXT, 8, 0 );
        SendMessage(RegKey2_hWnd, EM_LIMITTEXT, 8, 0 );
        SendMessage(RegKey3_hWnd, EM_LIMITTEXT, 8, 0 );

        CenterWindow(RegistrationDialog_hWnd);

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_COMMAND) // Received A Message
    {
        if(wParam == IDC_OK) //- Okay (Dialog Command)
        {
            int Length = 0;

            Length = Get_TextEx(RegKey1_hWnd, RegKey1, 16);
            if(Length < 8 || Length > 8)
            {
                MessageBox(RegistrationDialog_hWnd, PleaseEnterValidReg, TitleCaption, 0);
                return 0;
            }

            Length = Get_TextEx(RegKey2_hWnd, RegKey2, 16);
            if(Length < 8 || Length > 8)
            {
                MessageBox(RegistrationDialog_hWnd, PleaseEnterValidReg, TitleCaption, 0);
                return 0;
            }

            Length = Get_TextEx(RegKey3_hWnd, RegKey3, 16);
            if(Length < 8 || Length > 8)
            {
                MessageBox(RegistrationDialog_hWnd, PleaseEnterValidReg, TitleCaption, 0);
                return 0;
            }

            if(VerifiyKey(CodedKeysDB, RegKey1, RegKey2, RegKey3))
            {
                MessageBox(RegistrationDialog_hWnd, "Thank you for registering SQLBackup!", TitleCaption, 0);

                CheckRegistration = TRUE;
                IsRegistered = TRUE;

                EndDialog(RegistrationDialog_hWnd,0);
                DestroyWindow(RegistrationDialog_hWnd);
                return 0;
            }
            else{
                MessageBox(RegistrationDialog_hWnd, "The registration code is invalid!", TitleCaption, 0);
                return 0;
            }

            return 0;
        }

        if(wParam == IDC_CANCEL) //- Cancel (Dialog Command)
        {
            EndDialog(RegistrationDialog_hWnd,0);
            DestroyWindow(RegistrationDialog_hWnd);
            return 0;
        }

        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_CLOSE)  // Received Close Message
    {
        EndDialog(RegistrationDialog_hWnd,0);
        DestroyWindow(RegistrationDialog_hWnd);
        return 0;
    }

    //--------------------------------------------------------------------------

    if(xMessage == WM_DESTROY) // Received Destroy Message
    {
//        PostQuitMessage(0);
        return 0;
    }

    //--------------------------------------------------------------------------

    return 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

